local tileW, tileH, tileset, quads, tileTable

function loadMap(caminho)
  love.filesystem.load(caminho)()
end

function newMap(tileWidth, tileHeight, tilesetCaminho, tileString, quadInfo)

	tileW = tileWidth
	tileH = tileHeight
	Tileset = love.graphics.newImage(tilesetCaminho)

	tilesetW, tilesetH = Tileset:getWidth(), Tileset:getHeight()

	quads = {}

	local tilesetW, tilesetH = Tileset:getWidth(), Tileset:getHeight()

	for _, info in ipairs(quadInfo) do
		quads[info[1]] = love.graphics.newQuad(info[2], info[3], tileW, tileH, tilesetW, tilesetH)
	end

	tileTable = {}
	
	local width = #(tileString:match("[^\n]+")) 

	for x = 1, width, 1 do tileTable[x] = {} end

	local x, y = 1, 1 
	for row in tileString:gmatch("[^\n]+") do
		assert(#row == width, 'Map is not aligned: width of row ' .. tostring(y) .. ' should be ' .. tostring(width) .. ', but it is ' .. tostring(#row))
		x = 1 
		for character in row:gmatch(".") do 
			tileTable[x][y] = character 
			x = x + 1 
		end 
		y = y + 1 
	end 

end

function drawMap()

	for columnIndex, column in ipairs(tileTable) do
		for rowIndex, char in ipairs(column) do
			x, y = (columnIndex-1)*tileW, (rowIndex-1)*tileH
			love.graphics.draw(Tileset, quads[char], x, y)
		end
	end

end